import greenfoot.*;

public class Ghost extends Actor
{
    private GreenfootSound ghostDie = new GreenfootSound("ghost.mp3");
    private int ghost;
    private int exitTimer, imageTimer, weakTimer;
    public int direction;
    private boolean dead;

    public Ghost()
    {
    }
    
    public void addedToWorld(World w)
    {
        ghost = w.getObjects(Ghost.class).size()-1;
        setImage("ghost"+ghost+".png");
        exitTimer = ghost*100+50;
        if (ghost == 3) direction = 180;
    }

    public void act()
    {
        if (!((Maze)getWorld()).running) return;
        if (dead)
        {
            if (getX() == 228 && getY() == 300)
            {
                dead = false;
                exitTimer = 1;
                weakTimer = 0;
                return;
            }
            if (Math.abs(getX()-228) > Math.abs(getY()-300))
            {
                if (getX()-228 > 0) direction = 180; else direction = 0;
            }
            else
            {
                if (getY()-300 > 0) direction = 270; else direction = 90;
            }
            setRotation(direction);
            move(2);
            setRotation(0);
            setImage("deadghost"+(direction/90)+".png");
            return;
        }
        if (exitTimer > 0) exitTimer--;
        if (exitTimer == 0 && getX() == 228 && getY() <= 300 && getY() > 252)
        {
            if (getX() == 228) setImage("ghost"+ghost+"u.png");
            setLocation(getX(), getY()-2);
            return;
        }
        setDirection();
        direction = getRotation();
        move(2);
        if (getX() < 0) setLocation(getWorld().getWidth(), getY());
        if (getX() > getWorld().getWidth()) setLocation(0, getY());
        setRotation(0);
        imageTimer = (imageTimer+1)%8;
        if (weakTimer == 0)
        {
            if (direction%180 == 0) setImage("ghost"+ghost+"rl".charAt(direction/180)+(imageTimer/4)+".png");
            else setImage("ghost"+ghost+"du".charAt((direction-90)/180)+".png");
        }
        else 
        {
            weakTimer--;
            while (weakTimer > 100 && (weakTimer%8)/4 == 1) weakTimer--;
            setImage("weakghost"+((weakTimer%8)/4)+".png");
        }
    }

    public void setDirection()
    {
        setRotation(direction);
        int dirs = 0;
        turn(-90); 
        for (int i=0; i<3; i++) {
            if (canMove()) dirs++;
            turn(90);
        }
        if (dirs == 0) return;
        int choice = Greenfoot.getRandomNumber(dirs);
        while (choice>=0) {
            turn(90);
            if (canMove()) choice--;
        }
    }

    private boolean canMove()
    {
        move(2);
        Actor mur = getOneIntersectingObject(Wall.class);
        move(-2);
        return mur == null;
    }
    
    public void setWeak()
    {
        weakTimer = 600;
    }
    
    public boolean isWeak()
    {
        return weakTimer > 0;
    }
    
    public void die()
    {
        ghostDie.play();
        dead = true;
        
    }
    
    public boolean isDead()
    {
        return dead;
    }
}