import greenfoot.*;

public class Intro extends World
{
    private GreenfootSound intro = new GreenfootSound("intro.mp3");
    private GreenfootImage[] images1 = new GreenfootImage[4];
    private GreenfootImage[] images2 = new GreenfootImage[4];
    private int imgX = 536;
    private boolean phaze2;
    private boolean introStarted;
    
    public Intro()
    {
        super(456, 576, 1, false);
        Color c = getBackground().getColorAt(5, 5);
        for (int i=0; i<4; i++)
        {
            images1[i] = new GreenfootImage(260, 60);
            images1[i].setColor(c);
            images1[i].fill();
            GreenfootImage man = new GreenfootImage("pacman"+i+".png");
            man.scale(60, 60);
            images1[i].drawImage(man, 0, 0);
            for (int j=0; j<4; j++)
            {
                GreenfootImage ghost = new GreenfootImage("ghost"+j+"l"+(i%2)+".png");
                images1[i].drawImage(ghost, 80+44*j, 18);
            }
        }
        c = getBackground().getColorAt(5, 300);
        for (int i=0; i<4; i++)
        {
            images2[i] = new GreenfootImage(260, 48);
            images2[i].setColor(c);
            images2[i].fill();
            for (int j=0; j<4; j++)
            {
                GreenfootImage ghost = new GreenfootImage("ghost"+j+"r"+(i%2)+".png");
                ghost.scale(48, 48);
                images2[i].drawImage(ghost, 212-58*j, 0);
            }
            GreenfootImage man = new GreenfootImage("pacman"+i+".png");
            man.mirrorHorizontally();
            images2[i].drawImage(man, 14, 12);
        }  
        Actor actor = new Food();
        getBackground().drawImage(actor.getImage(), 172, 286);
        actor = new Pill();
        getBackground().drawImage(actor.getImage(), 168, 312);
        GreenfootImage image = new GreenfootImage("weakghost0.png");
        getBackground().drawImage(image, 164, 336);
        Greenfoot.setSpeed(48);
    }
    
    public void act()
    {
        if (!introStarted)
        {
            intro.play();
            introStarted = true;
        }
        if (!phaze2)
        {
            imgX -= 8;
            getBackground().drawImage(images1[((2136-imgX)/16)%4], imgX, 120);
            if (imgX <= -260) phaze2 = true;
        }
        else
        {
            imgX += 8;
            getBackground().drawImage(images2[((2136-imgX)/16)%4], imgX, 120);
        }
        if (!intro.isPlaying()) Greenfoot.setWorld(new Maze());
    }
}