import greenfoot.*;

public class Wall extends Actor
{
    public Color BLUE = new Color(0, 0, 128);
    public Color GRAY = new Color(128, 128, 255);
    
    public Wall(int part)
    {
        setImage(getImage(part));
    }

    private GreenfootImage getImage(int type)
    {
        GreenfootImage image = new GreenfootImage(24, 24);
        GreenfootImage base = null;
        switch (type)
        {
            case 0: break;
            case 2: case 3: // thin walls
                image.setColor(GRAY);
                image.fill();
                image.setColor(BLUE);
                image.drawRect(-1, 0, 25, 23);
                break;
            case 4: case 5: case 6: case 7: // wall ends
                base = new GreenfootImage(19, 19);
                base.setColor(GRAY);
                base.fillOval(0, 0, 18, 18);
                base.setColor(BLUE);
                base.drawOval(0, 0, 18, 18);
                while (base.getWidth()<48) base.scale(base.getWidth()+1, base.getHeight());
                while (base.getHeight()<24) base.scale(base.getWidth(),base.getHeight()+1);
                image.drawImage(base, 0, 0);
                break;
            case 8: case 9: case 10: case 11: // corners
                base = new GreenfootImage(24, 24);
                base.setColor(GRAY);
                base.fillOval(0, 0, 23, 23);
                base.setColor(BLUE);
                base.drawOval(0, 0, 23, 23);
                while (base.getWidth()<48) base.scale(base.getWidth()+1, base.getHeight());
                GreenfootImage split = new GreenfootImage(24, 12);
                split.drawImage(base, 0, 0);
                image.drawImage(split, 0, 0);
                image.mirrorVertically();
                image.rotate(90);
                image.drawImage(split, 0, 0);
                image.setColor(GRAY);
                image.fillRect(12, 12, 15, 15);
                break;
            case 12: case 13: case 14: case 15: // thick wall edge
                image.setColor(GRAY);
                image.fill();
                image.setColor(BLUE);
                image.drawLine(-1, 0, 25, 0);
                break;
            case 18: // gate
                image.setColor(GRAY);
                image.fillRect(-1, 10, 25, 4);
                image.setColor(BLUE);
                image.drawRect(-1, 10, 25, 4);
                break;
        }
        image.rotate(90*type);
        return image;
    }        

    public void addedToWorld(World w)
    {
        w.removeObjects(getIntersectingObjects(Food.class));
    }
}